<template>
  <v-flex>
    <v-flex xs12 class="text-end py-3">
      <v-badge class="align-self-center" overlap="overlap" color="red">
        <template v-slot:badge>
          <span>{{(checkCount)? count : 0}}</span>
        </template>
        <v-icon large color="primary" @click="gotoFinalPhoto">mdi-cart</v-icon>
      </v-badge>
      <template v-if="selectedbtn">
       <v-badge class="align-self-center" overlap="overlap" color="red">
        <template v-slot:badge>
          <span>{{(checkPhotoSelected)? photoSelected.length : 0}}</span>
        </template>
         <v-btn text @click="updatePhoto" v-if="selectedbtn" color="primary">Save</v-btn>
      </v-badge>
      </template>
      <!-- <v-btn text @click="updatePhoto" v-if="selectedbtn" color="primary">Save</v-btn> -->
      <v-btn text @click="logout" color="primary">logout</v-btn>
    </v-flex>
    <!-- <v-flex xs12>
      <v-alert
        type="warning"
        color="orange"
        class="mb-3"
      >
      {{limitText}}
    </v-alert>
    </v-flex> -->
    <v-card>
      <v-container grid-list-md>
        <v-layout row wrap>
          <v-flex xs12 md6 lg3 v-for='n in listPhoto' :key='n.id' v-bind:class="{ 'd-none' : !n.lastTransactions }">

            <v-card
              max-width="344"
              class="mx-auto"
            >
              <v-img
                :src="mapPic(n.lastTransactions)"
                height="194"
              ></v-img>

              <v-card-actions >
                <v-layout row wrap>
                  <v-flex xs12>
                      <v-card-text class="a" >
                        Name : {{ n.fullName }} <br>
                        Mobile No. : {{ n.mobileNo }} <br>
                        E-mail : {{ n.email }} <br>
                        Update : {{lastDate(n.lastTransactions)}}
                      </v-card-text>
                      <v-divider class="mx-3"></v-divider>
                      <v-flex  class="text-xs-center">
                        <v-flex v-if="countAll < 300">
                          <v-btn text color="primary" @click="showPic(n.lastTransactions)"><v-icon color="primary">fas fa-search-plus</v-icon>ZOOM</v-btn>
                          <v-btn text color="red"  v-if="n.flagSelected"><v-icon color="red">far fa-check-circle</v-icon>Selected</v-btn>
                          <v-btn text color="primary" @click="changebtn(n)" v-else><v-icon color="primary">far fa-check-circle</v-icon>Select</v-btn>
                        </v-flex>
                        <v-flex v-else>
                          <v-btn text color="primary" @click="showPic(n.lastTransactions)"><v-icon color="primary">fas fa-search-plus</v-icon>ZOOM</v-btn>
                          <v-btn text color="red" disabled><v-icon color="red">far fa-check-circle</v-icon>Selected</v-btn>
                        </v-flex>
                      </v-flex>
                  </v-flex>
                </v-layout>
              </v-card-actions>
            </v-card>
          </v-flex>
        </v-layout>
      </v-container>
    </v-card>
    <v-flex xs12 v-if="countAll >= 300">
     <v-snackbar
      v-model="snackbar"
      :auto-height="autoHeight"
    >
      {{ limitText }}
      <v-btn
        color="cyan"
        text
        @click="snackbar = false"
      >
        Close
      </v-btn>
    </v-snackbar>
    </v-flex>
  </v-flex>
</template>
<script>
import { fireStoreApp } from '@/firestore.init'
import { Promise } from 'q'
export default {
  created () {
    window.addEventListener('scroll', () => {
      this.bottom = this.bottomVisible()
      console.log(this.bottom)
    })
    let user = this.getUser()
    this.ref.listPhoto = fireStoreApp.collection('usersRegister').where('flagSelected', '==', false).orderBy(user, 'desc').limit(20)
    fireStoreApp.collection('usersRegister').where('flagSelected', '==', true).get().then((res) => {
      this.count = res.size
    })
    const firstPage = this.ref.listPhoto.limit(this.paging.question_per_page)
    this.handleQuestions(firstPage)
  },
  data: () => ({
    listPhoto: [],
    bottom: false,
    selectedbtn: false,
    snackbar: true,
    count: 0,
    autoHeight: true,
    limitText: 'Sorry, you selected 300 photo lists completely. If you require to change photo, plese click the cart icon > Final Customer Photo Lists to select outsome photo lists.',
    paging: {
      question_per_page: 20,
      end: false,
      loading: false
    },
    ref: {
      listPhoto: null,
      listPhotoNext: null
    }
  }),
  methods: {
    async updateAll (collection, dataIDs) {
      const set = dataIDs.map(id => collection.doc(id).set({ flagSelected: true }, { merge: true }))
      try {
        await Promise.all(set)
      } catch (err) {
        console.log(err)
        return 'fail'
      }
      return 'success'
    },
    gotoFinalPhoto () {
      window.open('/finalPhotoLists')
    },
    updatePhoto () {
      this.$store.dispatch('app/runLoader', true)
      const col = fireStoreApp.collection('usersRegister')
      const ids = this.photoSelected.map(x => x.id)
      this.updateAll(col, ids)
        .then((res) => {
          if (res === 'success') {
            this.$store.dispatch('app/runLoader', false)
            window.location.reload()
          } else {
            this.$store.dispatch('app/runLoader', false)
            console.log('Error')
          }
        })
    },
    changebtn (btn) {
      btn.flagSelected = true
      this.selectedbtn = true
      return btn
    },
    bottomVisible () {
      const scrollY = window.scrollY
      const visible = document.documentElement.clientHeight
      const pageHeight = document.documentElement.scrollHeight
      const bottomOfPage = Math.ceil(visible + scrollY) >= pageHeight

      return bottomOfPage || pageHeight < visible
    },
    loadMore () {
      if (this.paging.end) {
        return
      };

      this.paging.loading = true
      this.handleQuestions(this.ref.listPhotoNext).then((documentSnapshots) => {
        this.paging.loading = false

        if (documentSnapshots.empty) {
          /* If there is no more questions to load, set paging.end to true */
          this.paging.end = true
        }
      })
    },
    handleQuestions (ref) {
      return new Promise((resolve, reject) => {
        ref.get().then((documentSnapshots) => {
          /* If documentSnapshots is empty, then we have loaded all of pages */
          if (documentSnapshots.empty) {
            this.paging.end = true
            resolve(documentSnapshots)
          };

          documentSnapshots.forEach((doc) => {
            let questionData = doc.data()
            questionData.id = doc.id
            this.listPhoto.push(questionData)
          })

          /* Build reference for next page */
          const lastVisible = documentSnapshots.docs[documentSnapshots.size - 1]

          if (!lastVisible) {
            return
          };

          this.ref.listPhotoNext = this.ref.listPhoto
            .startAfter(lastVisible)
            .limit(this.paging.question_per_page)

          resolve(documentSnapshots)
        })
      })
    },
    mapPic (pic) {
      if (pic) {
        return pic[0].rawPicUrl
      }
      return ''
    },
    getUser () {
      let ranN
      let user = this.$store.getters['userReport/getUsername']
      if (user === 'committee01@dunlopillothai.com') {
        ranN = 'randomRef1'
      } else if (user === 'committee02@dunlopillothai.com') {
        ranN = 'randomRef2'
      } else {
        ranN = 'randomRef3'
      }
      return ranN
    },
    // shuffle( list ){
    //     let copy = [], n = list.length, i
    //   // While there remain elements to shuffle…
    //   while (n) {

    //     // Pick a remaining element…
    //     i = Math.floor(Math.random() * list.length)

    //     // If not already shuffled, move it to the new array.
    //     if (i in list) {
    //       copy.push(list[i])
    //       delete list[i]
    //       n--
    //     }
    //   }
    //   return copy
    // },
    lastDate (time) {
      if (time) {
        let lastSeconds = time[0].createAt.seconds
        let Fdate = new Date(0)
        Fdate.setSeconds(lastSeconds)
        let day = Fdate.getDate()
        let month = Fdate.getMonth() + 1
        let year = Fdate.getFullYear()
        let hour = Fdate.getHours()
        let min = Fdate.getMinutes()
        let second = Fdate.getSeconds()
        let dateShow = [year, month, day].join('-')
        // let time = [hour, min, second].join(':')
        let dateTime = dateShow + ' ' + hour + ':' + min + ':' + second
        return dateTime
      }
      return ''
    },
    showPic (pic) {
      if (pic) {
        window.open(pic[0].rawPicUrl, '_blank')
      }
    },
    logout () {
      this.$store.dispatch('userReport/logout')
    }
  },
  watch: {
    bottom (bottom) {
      if (bottom) {
        this.loadMore()
      }
    }
  },
  computed: {
    photoSelected () {
      if (this.selectedbtn) {
        const datas = this.listPhoto.filter(data => (data.flagSelected === true))
        return datas
      }
      return []
    },
    checkPhotoSelected () {
      return !!this.photoSelected
    },
    checkCount () {
      return !!this.count
    },
    countAll () {
      if (this.checkPhotoSelected) {
        console.log(this.count + this.photoSelected.length)
        return this.count + this.photoSelected.length
      }
      return 0 + this.count
    }
  }
}
</script>
<style>
div.a {
  white-space: nowrap;
  width: 250px;
  overflow: hidden;
  text-overflow:ellipsis;
}

div.a:hover {
  overflow: visible;
}
loading {
  text-align: center;
  position: absolute;
  color: #fff;
  z-index: 9;
  background: #5c4084;
  padding: 8px 18px;
  border-radius: 5px;
  left: calc(50% - 45px);
  top: calc(50% - 18px);
}
</style>
